package fust2013.aop.generics.aspects;

import org.aspectj.lang.Aspects;

import fust2013.aop.generics.observers.HeroTracker;
import fust2013.aop.generics.subjects.Hero;

public aspect HeroObserver extends ObserverProtocol<Hero,HeroTracker> {
	protected pointcut subjectChange(Hero s):
		call(void Hero.set*(..)) && target(s);
	
	@Override
	protected void updateObserver(Hero s, HeroTracker o) {
		o.onChange(s);
	}

	public void Hero.addObserver(HeroTracker o) {
		Aspects.aspectOf(HeroObserver.class).addObserver(this, o);
	}

	public void Hero.removeObserver(HeroTracker o) {
		Aspects.aspectOf(HeroObserver.class).removeObserver(this, o);
	}
}