package fust2013.aop.script;

import org.aspectj.lang.Aspects;

import fust2013.aop.script.aspects.HeroObserver;
import fust2013.aop.script.observers.HeroTracker;
import fust2013.aop.script.subjects.Hero;

public class ObserverDemo {
	public static void main(String[] args) {
		Hero p1 = new Hero("Donald Duck");
		Hero p2 = new Hero("Bruce Banner");
		HeroTracker pt1 = new HeroTracker("tracker1");
		HeroTracker pt2 = new HeroTracker("tracker2");

		Aspects.aspectOf(HeroObserver.class).addObserver(p1, pt1);
		p2.addObserver(pt1);

		p1.setName("Phantomias");
		p2.setName("Hulk");

		Aspects.aspectOf(HeroObserver.class).removeObserver(p2, pt2);
		p2.setShoeSize(66);
		p2.removeObserver(pt1);
	}
}