package fust2013.aop.script;

import org.aspectj.lang.Aspects;

import fust2013.aop.script.aspects.HeroObserver;
import fust2013.aop.script.observers.SimpleBeanTracker;
import fust2013.aop.script.subjects.Hero;
import fust2013.aop.script.subjects.SimpleBean;

public class WeirdnessDemo {
	public static void main(String[] args) {
		SimpleBean sb = new SimpleBean("bean1", 123);
		Hero wesley = new Hero("Wesley Gibson");
		SimpleBeanTracker sbt = new SimpleBeanTracker();

		// register SimpleBean subject and observer through aspect of Hero
		Aspects.aspectOf(HeroObserver.class).addObserver(sb, sbt);
		// register observer of SimpleBean for Hero
		Aspects.aspectOf(HeroObserver.class).addObserver(wesley, sbt);

		// no reaction -> Pointcut of Advice doesn't match class of subject
		sb.setName("bean2");
		// ClassCastException
		wesley.setName("The Killer");
	}
}