package fust2013.aop.script.aspects;

import org.aspectj.lang.Aspects;

import fust2013.aop.script.observers.HeroTracker;
import fust2013.aop.script.subjects.Hero;

public aspect HeroObserver extends ObserverProtocol {
	declare parents: Hero implements Subject;
	declare parents: HeroTracker implements Observer;

	protected pointcut subjectChange(Subject s):
		call(void Hero.set*(..)) && target(s);
	
	@Override
	protected void updateObserver(Subject s, Observer o) {
		((HeroTracker)o).onChange((Hero)s);
	}	

	public void Hero.addObserver(HeroTracker o) {
		Aspects.aspectOf(HeroObserver.class).addObserver(this, o);
	}

	public void Hero.removeObserver(HeroTracker o) {
		Aspects.aspectOf(HeroObserver.class).removeObserver(this, o);
	}
}