package fust2013.aop.script.aspects;

import org.aspectj.lang.Aspects;

import fust2013.aop.script.observers.SimpleBeanTracker;
import fust2013.aop.script.subjects.SimpleBean;

public aspect SimpleBeanObserver extends ObserverProtocol {
	declare parents: SimpleBean implements Subject;
	declare parents: SimpleBeanTracker implements Observer;

	protected pointcut subjectChange(Subject s):
		call(void SimpleBean.set*(..)) && target(s);
	
	@Override
	protected void updateObserver(Subject s, Observer o) {
		((SimpleBeanTracker)o).beanChanged((SimpleBean)s);
	}

	public void SimpleBean.addObserver(SimpleBeanTracker o) {
		Aspects.aspectOf(HeroObserver.class).addObserver(this, o);
	}

	public void SimpleBean.removeObserver(SimpleBeanTracker o) {
		Aspects.aspectOf(HeroObserver.class).removeObserver(this, o);
	}
}